package com.example.parsexml;

import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity {
	
	private Button parseXmlBtn;
	private TextView resultTv;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		parseXmlBtn = (Button)findViewById(R.id.parseXML);
		resultTv = (TextView)findViewById(R.id.result);
		parseXmlBtn.setOnClickListener(parseXmlBtnListener);
	}
	
	private OnClickListener parseXmlBtnListener  = new OnClickListener(){
		@Override
		public void onClick(View arg0) {
			new ParseWithAsyncTask().execute();
		}
	};
	
	private ArrayList<HashMap<String, String>> loadXml(){
		HashMap<String, String> map = null;
		ArrayList<HashMap<String, String>> bookList = new ArrayList<HashMap<String, String>>();
    	try {
			URL url = new URL("http://www.comp.hkbu.edu.hk/~sigis/android/public/books.xml");
			
			URLConnection urlConn = url.openConnection();
			urlConn.setConnectTimeout(10000);
			urlConn.connect();
			
	    	DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
	    	DocumentBuilder db = dbf.newDocumentBuilder();
			Document doc = db.parse(new InputSource(url.openStream()));
			doc.getDocumentElement().normalize();
			
			NodeList items = doc.getElementsByTagName("book");
			for (int i = 0; i < items.getLength(); i++) {
				Node item = items.item(i);
				NodeList properties = item.getChildNodes();
				map = new HashMap<String, String>();
				
				for (int j=0;j<properties.getLength();j++){
					Node property = properties.item(j);
                    String name = property.getNodeName();
                    
                    if (name.equalsIgnoreCase("name")){
                    	map.put("name", property.getFirstChild().getNodeValue());
                    	NamedNodeMap nnm = property.getAttributes();
                    	Attr attribute = (Attr) nnm.item(0);
                    	map.put("isbn", attribute.getValue());
                    }else if (name.equalsIgnoreCase("author")){
                    	map.put("author", property.getFirstChild().getNodeValue());
                    }else if (name.equalsIgnoreCase("publisher")){
                    	map.put("publisher", property.getFirstChild().getNodeValue());
                    }
				}
				
				bookList.add(map);
			}
			
			return bookList;
		} catch (Exception e) {
			e.printStackTrace();
			return new ArrayList<HashMap<String, String>>();
		}
    }

	private class ParseWithAsyncTask extends AsyncTask<Void, Void, ArrayList<HashMap<String, String>>> {
    	@Override
        protected ArrayList<HashMap<String, String>> doInBackground(Void... params) {
    		return loadXml();
        }
        @Override 
        protected void onPostExecute(ArrayList<HashMap<String, String>> result) {
        	super.onPostExecute(result);
        	String tvText = "";
        	for(int i=0; i<result.size(); i++){
	       		HashMap<String, String> map = result.get(i);
	       		tvText += map.get("name") + " (ISBN:" + map.get("isbn") +  ")" + "\n" + map.get("author") + "\n" + map.get("publisher") + "\n\n";
	       	}
	       	resultTv.setText(tvText);
        }
    }
}