package com.example.googlemapsv2;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.CameraPosition.Builder;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;

public class MainActivity extends FragmentActivity {
	
	private GoogleMap googleMap;
	private LocationManager locationManager;
	private LocationListener locationListener;
	private Builder cameraPositionBuilder;
	private CameraPosition cameraPosition;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		googleMap = ((SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map)).getMap();
		
		MarkerOptions markerOptions = new MarkerOptions();
		markerOptions.position(new LatLng(22.340405, 114.179580));
		markerOptions.title("RRS 638, Sir Run Run Shaw Building HKBU");
		markerOptions.icon(BitmapDescriptorFactory.fromResource(R.drawable.csd_logo));
		markerOptions.snippet("Department of Computer Science");
		googleMap.addMarker(markerOptions);
		
		cameraPositionBuilder = new CameraPosition.Builder();
		cameraPositionBuilder.zoom(17);
		
		locationManager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);
		locationListener = new LocationListener() {
			@Override
			public void onLocationChanged(Location location) {
				cameraPositionBuilder.target(new LatLng(location.getLatitude(), location.getLongitude()));
				cameraPosition = cameraPositionBuilder.build();
				googleMap.animateCamera(CameraUpdateFactory.newCameraPosition(cameraPosition));
			}

			@Override
			public void onStatusChanged(String provider, int status, Bundle extras) {}

			@Override
			public void onProviderEnabled(String provider) {}

			@Override
			public void onProviderDisabled(String provider) {}

		};
        locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, locationListener);
        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, locationListener);
	}
}